import { jsx as l, jsxs as k } from "react/jsx-runtime";
import y from "react";
import o from "clsx";
const V = (e, t, r) => {
  var a;
  !t && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof r == "function" && r(e);
}, N = y.forwardRef(
  (e, t) => {
    const { onClick: r, noInternalClick: a = !1, ...c } = e;
    return /* @__PURE__ */ l(
      "button",
      {
        ref: t,
        onClick: (i) => {
          V(i, a, r);
        },
        ...c
      }
    );
  }
);
N.displayName = "BaseButton";
const C = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
}, w = "av-button", B = "icon", E = "button", T = "link", W = ({
  type: e,
  size: t,
  labelRight: r,
  labelLeft: a,
  align: c
}) => {
  const i = "text-sm font-medium max-h-8 py-0", s = "text-base font-medium max-h-9 py-1", d = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case E:
      return o("px-4", {
        [i]: t === "small",
        [s]: t === "medium",
        [d]: t === "large"
      });
    case T:
      return o("px-4 text-center", {
        [i]: t === "small",
        [s]: t === "medium",
        [d]: t === "large"
      });
    case B:
      return o("inline-flex items-center", {
        "justify-center": c === "center",
        "justify-start": c === "left",
        "justify-end": c === "right",
        "h-6 w-6 p-0": t === "small" && !(r || a),
        "h-6 px-4 text-sm font-medium": t === "small" && (r || a),
        "h-8 w-8 p-1": t === "medium" && !(r || a),
        "h-8 px-4 text-base font-medium": t === "medium" && (r || a),
        "h-12 w-12 p-2": t === "large" && !(r || a),
        "h-12 px-4 text-lg font-medium": t === "large" && (r || a)
      });
  }
}, U = ({
  mode: e,
  noBackground: t,
  noTruncate: r,
  variant: a
}) => {
  if (t)
    return "not-prose rounded-full";
  if (a === "primary")
    return o("not-prose rounded-full", {
      truncate: !r,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return o("not-prose rounded-full", {
      truncate: !r,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return o("not-prose rounded-full", {
      truncate: !r,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
}, H = ({
  mode: e,
  disabled: t,
  variant: r
}) => {
  if (t)
    return "";
  if (r === "primary")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (r === "secondary")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (r === "danger")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
}, A = ({
  mode: e,
  disabled: t,
  variant: r
}) => {
  if (t)
    return "";
  if (r === "primary")
    return o("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (r === "secondary")
    return o("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (r === "danger")
    return o("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
}, S = ({
  mode: e,
  noBorder: t,
  variant: r
}) => {
  if (t)
    return "border border-transparent";
  if (r === "primary")
    return o("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (r === "secondary")
    return o("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (r === "danger")
    return o("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
}, O = ({ focusMode: e }) => o("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), _ = ({
  type: e,
  className: t,
  raw: r,
  mode: a,
  focusMode: c,
  disabled: i,
  fullWidth: s,
  size: d,
  noBorder: u,
  labelRight: h,
  labelLeft: m,
  spacing: v,
  noBackground: b,
  variant: n,
  noTruncate: f,
  align: g
}) => (n || (n = "primary"), r ? o(w, t) : o(
  w,
  t,
  C(v),
  U({ mode: a, variant: n, noBackground: b, noTruncate: f }),
  W({ type: e, size: d, labelRight: h, labelLeft: m, align: g }),
  S({ mode: a, variant: n, noBorder: u }),
  O({ focusMode: c }),
  H({ mode: a, variant: n, disabled: i }),
  A({ mode: a, variant: n, disabled: i }),
  {
    "w-full": s,
    "disabled:cursor-not-allowed disabled:opacity-50": i
  }
)), M = y.forwardRef(
  ({
    children: e,
    mode: t = "system",
    focusMode: r = "system",
    fullWidth: a = !1,
    className: c,
    size: i = "small",
    raw: s = !1,
    noBorder: d = !1,
    target: u,
    noTruncate: h = !1,
    noNewWindowIcon: m = !1,
    spacing: v,
    ...b
  }, n) => {
    const f = _({
      type: T,
      mode: t,
      focusMode: r,
      fullWidth: a,
      disabled: !1,
      raw: s,
      className: c,
      size: i,
      noBorder: d,
      spacing: v,
      noTruncate: h
    }), g = u === "_blank", p = {
      target: u,
      rel: g ? "noopener noreferrer" : void 0,
      ...b
    }, x = o({
      truncate: !h,
      "basis-11/12": !h && g
    });
    return /* @__PURE__ */ l("a", { ref: n, className: f, ...p, children: /* @__PURE__ */ k("div", { role: "text", className: "flex items-center justify-center", children: [
      /* @__PURE__ */ k("div", { className: x, children: [
        e,
        g && /* @__PURE__ */ l("span", { className: "sr-only", children: ", opens in a new window" })
      ] }),
      g && !m && /* @__PURE__ */ k(
        "svg",
        {
          xmlns: "http://www.w3.org/2000/svg",
          viewBox: "0 0 448 512",
          className: "ml-1 size-4 basis-4",
          fill: "currentColor",
          "aria-hidden": "true",
          children: [
            /* @__PURE__ */ l(
              "path",
              {
                opacity: ".4",
                d: "M384 32c35.3 0 64 28.7 64 64V416c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V96C0 60.7 28.7 32 64 32H384zM160 144c-13.3 0-24 10.7-24 24s10.7 24 24 24h94.1L119 327c-9.4 9.4-9.4 24.6 0 33.9s24.6 9.4 33.9 0l135-135V328c0 13.3 10.7 24 24 24s24-10.7 24-24V168c0-13.3-10.7-24-24-24H160z"
              }
            ),
            /* @__PURE__ */ l("path", { d: "M312 144H160c-13.3 0-24 10.7-24 24s10.7 24 24 24h94.1L119 327c-9.4 9.4-9.4 24.6 0 33.9s24.6 9.4 33.9 0l135-135V328c0 13.3 10.7 24 24 24s24-10.7 24-24V168c0-13.3-10.7-24-24-24z" })
          ]
        }
      )
    ] }) });
  }
);
M.displayName = "ButtonLink";
/*!
  @versini/ui-button v1.0.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "1.0.1",
    buildTime: "09/16/2024 09:44 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const $ = y.forwardRef(
  ({
    children: e,
    disabled: t = !1,
    mode: r = "system",
    focusMode: a = "system",
    fullWidth: c = !1,
    className: i,
    type: s = "button",
    raw: d = !1,
    noBorder: u = !1,
    "aria-label": h,
    label: m,
    size: v = "medium",
    labelRight: b,
    labelLeft: n,
    spacing: f,
    noBackground: g = !1,
    align: p = "center",
    active: x = !1,
    ...z
  }, R) => {
    const I = _({
      type: B,
      mode: r,
      focusMode: a,
      fullWidth: c,
      disabled: t,
      raw: d,
      className: i,
      noBorder: u,
      size: v,
      labelRight: b,
      labelLeft: n,
      spacing: f,
      noBackground: g,
      align: p
    }), L = o({
      "text-copy-accent-dark": r === "light" && !d,
      "text-copy-light": r === "dark" && !d,
      "text-copy-accent-dark dark:text-copy-light": r === "alt-system" && !d,
      "text-copy-light dark:text-copy-accent-dark": r === "system" && !d
    }), j = x ? o(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": r === "dark",
        "after:border-table-light": r === "light",
        "after:border-table-dark dark:after:border-table-light": r === "system",
        "after:border-table-light dark:after:border-table-dark": r === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ l("div", { className: j, children: /* @__PURE__ */ k(
      N,
      {
        ref: R,
        className: I,
        disabled: t,
        type: s,
        "aria-label": h || m,
        ...z,
        children: [
          n && /* @__PURE__ */ l("span", { className: "pr-2", children: n }),
          /* @__PURE__ */ l("div", { className: L, children: e }),
          b && /* @__PURE__ */ l("span", { className: "pl-2", children: b })
        ]
      }
    ) });
  }
);
$.displayName = "ButtonSort";
const D = y.forwardRef(
  ({ ...e }, t) => /* @__PURE__ */ l(M, { ref: t, ...e })
);
D.displayName = "Anchor";
export {
  D as Anchor
};
